<!-- SPDX-License-Identifier: CC-BY-4.0 -->

![](https://github.com/openmainframeproject/artwork/raw/master/projects/feilong/feilong-color.svg)

![License](https://img.shields.io/github/license/OpenMainframeProject/feilong)

# Feilong

## Description
Feilong is a SDK for managing z/VM. It provides a set of APIs to operate z/VM including guest, image, network, volume etc.

Just like os-win for the nova Hyper V driver and oslo.vmware for the nova VMware driver, Feilong is used by the nova z/VM driver and other z/VM related openstack drivers such as neutron and ceilometer.

## Quickstart
Please refer to [Quick Start Guide](https://feilong.readthedocs.io/en/latest/quickstart.html).

## Documentation
Please refer to [Documentation of Feilong](https://feilong.readthedocs.io/en/latest/).

## License
This package is licensed under the [Apache 2.0 License](LICENSE)

## Bug reporting
If you encounter any problem with this package, please open a bug against
[feilong issue tracker](https://github.com/openmainframeproject/feilong/issues)

## Governance
Feilong is a project hosted at the [Open Mainframe Project](https://openmainframeproject.com), and is openly governed as defined in [GOVERNANCE.md](GOVERNANCE.md).

----
<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/80x15.png" /></a><br />Documentation license: <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Attribution 4.0 International License</a>.
